/*
 * JBoss, Home of Professional Open Source.
 *
 * See the LEGAL.txt file distributed with this work for information regarding copyright ownership and licensing.
 *
 * See the AUTHORS.txt file distributed with this work for a full listing of individual contributors.
 */
package org.teiid.designer.query.proc.wsdl.model;

/**
 * This class represents a Binding as defined in a WSDL
 *
 * @since 8.0
 */
public interface IBinding extends IWsdlElement {

    /**
     * @return returns the operations defined within the Binding
     */
    IOperation[] getOperations();

    /**
     * @return the port that contains this binding
     */
    IPort getPort();

    /**
     * @return uri the URI for the SOAP Binding
     */
    String getTransportURI();

    /**
     * This returns the style information returned by the SOAP binding (RPC or DOC)
     * 
     * @return the style for the SOAP web service
     */
    String getStyle();
}
